// The header file defining the value of the node in sparse matrix.
// It could be any type.

#ifndef __NODE_H__
#define __NODE_H__

#include <iostream.h>

//using namespace std;

template <class nType>
class node {
	nType val;
	int rowNum, colNum;
public:
    // Constructors and destructor
    node ( const node<nType>* ); 
    //{ rowNum = n.rowNum; colNum = n.colNum; val = n.val; }

    node ( const int , const int , const nType );
    // { rowNum = row; colNum = col; val = value; }

    node (); // { rowNum = 0; colNum = 0; val = (nType) 0;} 

	~node() {}

    // Overloaded operators, including +, - , *, /, =
    inline void operator =(const node<nType>& n)
    { val = n.val; }

    inline void operator =(const nType value)
    { val = value; }

    inline nType operator +(const node<nType>& n)
    { return (val + n.val); }

    inline nType operator +(nType value)
    { return (val + value); }

    inline nType operator -(const node<nType>& n)
    { return val - n.val;}

    inline nType operator -(nType value)
    { return (val - value); }

    inline nType operator *(const node<nType>& n)
    { return val * n.val;}

    inline nType operator *(nType value)
    { return (val * value); }

    inline nType operator /(const node<nType>& n)
    { return val / n.val; }

    inline nType operator /(nType value)
    { return (val / value); }

	// get value and set value
	inline nType getVal() { return val; }
	inline void setVal(nType value) { val = value; }
	inline int rowNumber() { return rowNum;}
	inline int colNumber() { return colNum;}

};

// Constructors and destructor
template<class nType>
node<nType>::node ( const node<nType>* n )
{
    rowNum = n->rowNumber();
    colNum = n->colNumber();
    val = n->getVal();
}

template <class nType>
node<nType>::node ( const int row, const int col, const nType value)
{
    rowNum = row;
    colNum = col;
    val = value;
}

template <class nType>
node<nType>::node ()
{
    rowNum = 0;
    colNum = 0;
    val = (nType) 0;
}

#endif
